Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTERM.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTERM.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTERM.m	(revision 636)
@@ -1,6 +1,4 @@
-HLCSTERM ;ALB/RJS - SET UP VIDEO ATTRIBUTES ;06/27/2007  17:04
- ;;1.6;HEALTH LEVEL SEVEN;**40,49,122**;Oct 13, 1995;Build 14
- ;Per VHA Directive 2004-038, this routine should not be modified.
- ;
+HLCSTERM ;ALB/RJS - SET UP VIDEO ATTRIBUTES - 8/1/94 ;07/28/98  09:43
+ ;;1.6;HEALTH LEVEL SEVEN;**40,49**;Oct 13, 1995
 TERM ; -- set up term characteristics
  N X
@@ -25,8 +23,5 @@
  D WDATA^HLCSMON1(37,3,"","","MESSAGES",8),WDATA^HLCSMON1(37,4,IOUON,IOUOFF,"TO SEND ",8)
  D WDATA^HLCSMON1(47,3,"","","MESSAGES",8),WDATA^HLCSMON1(47,4,IOUON,IOUOFF,"SENT    ",8)
- ; patch HL*1.6*122
- ; D WDATA^HLCSMON1(57,3,"","","DEVICE",8),WDATA^HLCSMON1(57,4,IOUON,IOUOFF,"TYPE   ",8)
- D WDATA^HLCSMON1(57,3,"","","DEVICE",8),WDATA^HLCSMON1(57,4,IOUON,IOUOFF,"TYPE   ",6)
- ;
+ D WDATA^HLCSMON1(57,3,"","","DEVICE",8),WDATA^HLCSMON1(57,4,IOUON,IOUOFF,"TYPE   ",8)
  D WDATA^HLCSMON1(66,4,IOUON,IOUOFF,"STATE",8)
  Q
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLDIE.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLDIE.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLDIE.m	(revision 636)
@@ -1,6 +1,4 @@
-HLDIE ;CIOFO-O/LJA - Direct 772 & 773 Sets ; 10/19/2007 11:15
- ;;1.6;HEALTH LEVEL SEVEN;**109,122**;Oct 13,1995;Build 14
- ;Per VHA Directive 2004-038, this routine should not be modified.
- Q
+HLDIE ;CIOFO-O/LJA - Direct 772 & 773 Sets ; 11/18/2003 11:17
+ ;;1.6;HEALTH LEVEL SEVEN;**109**;Oct 13,1995
  ;
  ; Rules: if any of these rules is broken, FILE^DIE is called instead
@@ -75,12 +73,6 @@
  .I FILE=772 D DEL772^HLUOPT3(+IEN)
  ;
- ; patch HL*1.6*122: MPI-client/server
  ; If no data in record passed in, log an error and quit...
- ; I '$D(@GBL) D  Q  ; Remember.  GBL contains IEN...
- N HLDGBL
- F  L +@GBL:10 Q:$T  H 1
- S HLDGBL=$D(@GBL)
- L -@GBL
- I 'HLDGBL D  Q  ; Remember.  GBL contains IEN...
+ I '$D(@GBL) D  Q  ; Remember.  GBL contains IEN...
  .  S ERRNO=$$ERRNO(601,"The entry does not exist.",FILE,2)
  .  S @ERR@("DIERR",+ERRNO,"PARAM","IENS")=IEN_$S(IEN'[",":",",1:"")
@@ -118,10 +110,4 @@
  QUIT:'$D(NODE("CHG"))  ;->
  ;
- ; patch HL*1.6*122: MPI-client/server
- I FILE=773 D
- . F  L +^HLMA(IEN):10 Q:$T  H 1
- E  D
- . F  L +^HL(772,IEN):10 Q:$T  H 1
- ;
  ; Store changes in the global now...
  D STORE(FILE,IEN,.NODE)
@@ -131,8 +117,4 @@
  F  S XRF=$O(XRF(XRF)) Q:XRF']""  D
  .  D @("XRF"_XRF_U_ROUTINE)
- ;
- ; patch HL*1.6*122: MPI-client/server
- I FILE=773 L -^HLMA(IEN)
- E  L -^HL(772,IEN)
  ;
  Q
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLFNC.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLFNC.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLFNC.m	(revision 636)
@@ -1,6 +1,4 @@
-HLFNC ;AISC/SAW/OAK-OIFO/RBN-Routine of Functions and Other Calls Used for HL7 Messages  ;03/26/2008  11:34
- ;;1.6;HEALTH LEVEL SEVEN;**38,42,51,66,141**;Oct 13, 1995;Build 11
- ;Per VHA Directive 2004-038, this routine should not be modified.
- ;
+HLFNC ;AISC/SAW-Routine of Functions and Other Calls Used for HL7 Messages ;08/03/2000  15:45
+ ;;1.6;HEALTH LEVEL SEVEN;**38,42,51,66**;Oct 13, 1995
 HLNAME(X,HLECDE) ;Convert a name in DHCP format to HL7 format
  ; INPUT: X - Name in DHCP format
@@ -55,5 +53,5 @@
  Q $S(Y="DT":$E(%,1,8),1:%)
  ;
-FMDATE(X) ; Convert a date, date/time or time only in HL7 format to FM format
+FMDATE(X) ;Convert a date, date/time or time only in HL7 format to FM format
  I X="" Q ""
  N %
@@ -160,20 +158,5 @@
  Q:'$D(X) ""  Q:$L(X)<7 ""
  N I,Y,Y1,Z S B=$S('$D(B):"",1:"B"_B),C=$S('$D(C):"",1:"C"_C)
- ;
- ; patch HL*1.6*141 start
- ; S Y="" F I=1:1:$L(X) S Y=Y_$S($E(X,I)?1N:$E(X,I),"X,x"[$E(X,I)&('$D(Z)):"X",1:"") I "X,x"[$E(X,I) S Z=""
- N CH
- S Y=""
- F I=1:1:$L(X) D
- . S CH=$E(X,I)
- . ; Next line modified by RBN
- . ;S Y=Y_$S(CH?1N:CH,"Xx"[CH&('$D(Z)):"X",1:"")
- . S Y=Y_$S(CH?1N:CH,"Xx,*"[CH&('$D(Z)):"X",1:"")
- . I "Xx"[CH S Z=""
- ;
- ; the number, following "X" character, should be greater than 0
- I Y["X",+$P(Y,"X",2)<1 S Y=$P(Y,"X")
- ; patch HL*1.6*141 end
- ;
+ S Y="" F I=1:1:$L(X) S Y=Y_$S($E(X,I)?1N:$E(X,I),"X,x"[$E(X,I)&('$D(Z)):"X",1:"") I "X,x"[$E(X,I) S Z=""
  I $L(Y)<7 Q ""
  S Y1=$S(Y["X":"X"_$P(Y,"X",2),1:""),Y=$P(Y,"X") I $L(Y)<7 Q ""
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLMA.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLMA.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLMA.m	(revision 636)
@@ -1,4 +1,4 @@
-HLMA ;AISC/SAW-Message Administration Module ;10/24/2007  10:15
- ;;1.6;HEALTH LEVEL SEVEN;**19,43,58,63,66,82,91,109,115,133,132,122**;Oct 13, 1995;Build 14
+HLMA ;AISC/SAW-Message Administration Module ;10/25/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**19,43,58,63,66,82,91,109,115,133,132**;Oct 13, 1995;Build 6
  ;Per VHA Directive 2004-038, this routine should not be modified.
 GENERATE(HLEID,HLARYTYP,HLFORMAT,HLRESLT,HLMTIEN,HLP) ;
@@ -35,7 +35,5 @@
  ;   HLP("CONTPTR") = Continuation pointer, a 1 to 180 character string
  ; HLP("NAMESPACE") = Passed in by application namespace - HL*1.6*91
- ; HLP("EXCLUDE SUBSCRIBER",<n=1,2,3...>)=<subscriber protocol ien> or
- ;   <subscriber protocol name> - A list of protocols to dynamically
- ;   drop from the event protocol's subscriber multiple.
+ ; HLP("EXLCLUDE SUBSCRIBER",<n=1,2,3...>)=<subsciber protocol ien> - A list of protocols to dynamically drop from the event protocol's subscriber multiple.
  ;
  ;can't have link open when generating new message
@@ -44,7 +42,5 @@
  S HLRESLT=""
  ;Check for required parameters
-CONT ;
- I $G(HLEID)']""!($G(HLARYTYP)']"")!($G(HLFORMAT)']"") D  G EXIT
- . S HLRESLT="0^7^"_$G(^HL(771.7,7,0))_" at GENERATE^HLMA entry point"
+CONT I $G(HLEID)']""!($G(HLARYTYP)']"")!($G(HLFORMAT)']"") S HLRESLT="0^7^"_$G(^HL(771.7,7,0))_" at GENERATE^HLMA entry point" G EXIT
  I 'HLEID S HLEID=$O(^ORD(101,"B",HLEID,0)) I 'HLEID S HLRESLT="0^1^"_$G(^HL(771.7,1,0)) G EXIT
  N HLRESLT1,HLRESLTA S (HLRESLTA,HLRESLT1)=""
@@ -82,9 +78,4 @@
  I HLMIDAR K HLMIDAR("N") M HLRESLT=HLMIDAR
  S HLRESLT=HLRESLT_"^"_HLRESLT1
- ;
- ; patch HL*1.6*122
- S HLRESLT("HLMID")=$G(HLMIDAR("HLMID"))
- S HLRESLT("IEN773")=$G(HLMIDAR("IEN773"))
- ;
  ;Execute exit action for event driver protocol
  I HLEXROU]"" X HLEXROU
@@ -97,11 +88,9 @@
  ;Entry point to generate an immediate message, must be TCP Logical Link
  ;Input:
- ;  The same as GENERATE,with one additional subscript to the HLP input 
- ;  array:
+ ;  The same as GENERATE,with one additional subscript to the HLP input array:
  ; 
  ;  HLP("OPEN TIMEOUT") (optional, pass by reference) a number between 
  ;    1 and 120 that specifies how many seconds the DIRECT CONNECT should
- ;    try to open a connection before failing.  It is killed upon 
- ;    completion.
+ ;    try to open a connection before failing.  It is killed upon completion.
  ; 
  N HLTCP,HLTCPO,HLPRIO,HLSAN,HLN,HLMIDAR,HLMTIENR,ZMID,HLDIRECT
@@ -137,6 +126,4 @@
  ;I $P($G(^HLCS(870,HLDP,400)),U)="" W !,"Missing IP Address" Q
  D SETUP^HLCSAC G:HLCS PINGQ
- ; patch HL*1.6*122
- G:$$DONTPING^HLMA4 PINGQ
  ;PING header=MSH^PING^domain^PING^logical link^datetime
  S INPUT(1)="MSH^PING^"_HLDPDM_"^PING^"_HLDPNM_"^"_$$HTE^XLFDT($H)
@@ -147,11 +134,5 @@
  . ;non-standard HL7 header; start block,header,end block
  . S HLX1=$H
- . ;
- . ; HL*1.6*122 start
- . ; replace flush character '!' with @IOF (! or #)
- . ; W $C(11)_INPUT(1)_$C(28)_$C(13),! ;HL*1.6*115, restored ! char
- . W $C(11)_INPUT(1)_$C(28)_$C(13),@IOF
- . ; HL*1.6*122 end
- . ;
+ . W $C(11)_INPUT(1)_$C(28)_$C(13),! ;HL*1.6*115, restored ! char
  . ;read response
  . R X:HLDREAD
@@ -179,20 +160,10 @@
  N HLDOM,HLIP S HLCS=""
  S HLDOM=$P(^HLCS(870,HLDP,0),U,7)
- ; patch HL*1.6*122 start
- S HLDOM("DNS")=$P($G(^HLCS(870,+$G(HLDP),0)),"^",8)
- ; I 'HLDOM,'HLQUIET W !,"Domain Unknown" Q
- I 'HLDOM,($L(HLDOM("DNS"),".")<3) D  Q
- . I 'HLQUIET W !,"Domain Unknown"
- . S HLCS="-1^Connection Fail"
- ; patch HL*1.6*122 end
+ I 'HLDOM,'HLQUIET W !,"Domain Unknown" Q
  I HLDOM S HLDOM=$P(^DIC(4.2,HLDOM,0),U)
- ; patch HL*1.6*122
- ; I HLDOM]"" D  Q:'POP
- I HLDOM]""!($L(HLDOM("DNS"),".")>2) D  Q:'POP
+ I HLDOM]"" D  Q:'POP
  . I HLDOM["VA.GOV"&(HLDOM'[".MED.") S HLDOM=$P(HLDOM,".VA.GOV")_".MED.VA.GOV"
  . I HLTCPORT=5000 S HLDOM="HL7."_HLDOM
  . I HLTCPORT=5500 S HLDOM="MPI."_HLDOM
- . ; patch HL*1.6*122
- . I ($L(HLDOM("DNS"),".")>2) S HLDOM=HLDOM("DNS")
  . I 'HLQUIET W !,"Domain, "_HLDOM
  . I 'HLQUIET W !,"Port: ",HLTCPORT
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI1.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI1.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI1.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOAPI1 ;ALB/CJM-HL7 - Developer API's for sending & receiving messages(continued) ;07/18/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,132,134,137**;Oct 13, 1995;Build 21
+HLOAPI1 ;ALB/CJM-HL7 - Developer API's for sending & receiving messages(continued) ;02/06/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,132,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -54,9 +54,9 @@
  .I '$G(HLMSTATE("BODY")),'$G(HLMSTATE("UNSTORED LINES")) S ERROR="MESSAGE NOT YET CREATED" Q
  .;
- .I $$CHKPARMS^HLOAPI2(.HLMSTATE,.PARMS,.ERR1)&$$CHKWHO^HLOAPI2(.HLMSTATE,.WHOTO,.ERR2) D
+ .I $$CHKPARMS^HLOAPI2(.HLMSTATE,.PARMS,.ERR1)&$$CHKWHO(.HLMSTATE,.WHOTO,.ERR2) D
  ..I $$SEND(.HLMSTATE,.ERROR) S SUCCESS=1
  .E  D
- ..S ERROR=$G(ERR1)_": "_$G(ERR2)
- ..D DONTSEND(.HLMSTATE,ERROR)
+ .S ERROR=$G(ERR1)_": "_$G(ERR2)
+ .D DONTSEND(.HLMSTATE,ERROR)
  K PARMS,WHOTO
  Q $S(SUCCESS:HLMSTATE("IEN"),1:0)
@@ -106,5 +106,5 @@
  .K STATE M STATE=HLMSTATE S STATE("IEN")=""
  .S ERROR=""
- .I $$CHKWHO^HLOAPI2(.STATE,.WHO,.ERROR) D
+ .I $$CHKWHO(.STATE,.WHO,.ERROR) D
  ..I $$SEND(.STATE,.ERROR) D
  ...S WHOTO(I,"QUEUED")=1
@@ -190,14 +190,10 @@
  ;
  I '$$SAVEMSG^HLOF778(.HLMSTATE) S ERROR="$$SAVE^HLOF778 FAILED!" Q 0
- I HLMSTATE("BATCH"),$L($G(HLMSTATE("STATUS","SEQUENCE QUEUE"))) S ERROR="SEQUENCE QUEUES NOT SUPPORTED FOR BATCH MESSAGES" Q 0
- I $L($G(HLMSTATE("STATUS","SEQUENCE QUEUE"))) D
- .S HLMSTATE("STATUS","MOVED TO OUT QUEUE")=$$SQUE^HLOQUE(HLMSTATE("STATUS","SEQUENCE QUEUE"),HLMSTATE("STATUS","LINK NAME"),$G(HLMSTATE("STATUS","PORT")),HLMSTATE("STATUS","QUEUE"),HLMSTATE("IEN")) D:HLMSTATE("STATUS","MOVED TO OUT QUEUE")
- ..S $P(^HLB(HLMSTATE("IEN"),5),"^",2)=1
- E  D
- .D OUTQUE^HLOQUE(HLMSTATE("STATUS","LINK NAME"),$G(HLMSTATE("STATUS","PORT")),HLMSTATE("STATUS","QUEUE"),HLMSTATE("IEN"))
+ D OUTQUE^HLOQUE(HLMSTATE("STATUS","LINK NAME"),$G(HLMSTATE("STATUS","PORT")),HLMSTATE("STATUS","QUEUE"),HLMSTATE("IEN"))
  Q HLMSTATE("IEN")
  ;
 DONTSEND(HLMSTATE,ERROR) ;
- ;This procedure does NOT send a message.  Rather, it creates an entry in file 778 with the status ER.  
+ ;This procedure does NOT send a message.  Rather, it creates an entry in file 778 with the
+ ;of "SE".  
  ;Input:
  ;       HLMSTATE - pass-by-reference
@@ -207,7 +203,20 @@
  I HLMSTATE("UNSTORED LINES"),'$$SAVEMSG^HLOF777(.HLMSTATE) ; just continue
  ;
- S HLMSTATE("STATUS")="ER"
+ S HLMSTATE("STATUS")="SE"
  S HLMSTATE("STATUS","PURGE")=$$FMADD^XLFDT(HLMSTATE("DT/TM CREATED"),HLMSTATE("SYSTEM","ERROR PURGE"))
  S HLMSTATE("STATUS","ERROR TEXT")=$G(ERROR)
  I '$$SAVEMSG^HLOF778(.HLMSTATE) ;already reported an error to the app
  Q
+ ;
+CHKWHO(HLMSTATE,WHOTO,ERROR) ;
+ N RETURN,I
+ S RETURN=1
+ I '$$CHECKWHO^HLOASUB1(.WHOTO,.RETURN,.ERROR) S RETURN=0
+ ;
+ ;move parameters into HLMSTATE
+ S HLMSTATE("STATUS","LINK IEN")=$G(RETURN("LINK IEN"))
+ S HLMSTATE("STATUS","LINK NAME")=$G(RETURN("LINK NAME"))
+ S HLMSTATE("STATUS","PORT")=$P($G(RETURN("RECEIVING FACILITY",2)),":",2)
+ S HLMSTATE("HDR","RECEIVING APPLICATION")=$G(RETURN("RECEIVING APPLICATION"))
+ F I=1:1:3 S HLMSTATE("HDR","RECEIVING FACILITY",I)=$G(RETURN("RECEIVING FACILITY",I))
+ Q RETURN
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI2.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI2.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI2.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOAPI2 ;ALB/CJM-HL7 - Developer API's for sending application acks ;07/30/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,131,133,134,137**;Oct 13, 1995;Build 21
+HLOAPI2 ;ALB/CJM-HL7 - Developer API's for sending application acks ;12/11/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**126,131,133,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -66,5 +66,5 @@
  .S ACK("HDR","RECEIVING APPLICATION")=$G(HLMSTATE("HDR","SENDING APPLICATION"))
  .F I=1:1:3 S ACK("HDR","RECEIVING FACILITY",I)=$G(HLMSTATE("HDR","SENDING FACILITY",I))
- .S ACK("ACK TO","STATUS")=$S(PARMS("ACK CODE")="AA":"SU",1:"ER")
+ .S ACK("ACK TO","STATUS")=$S(PARMS("ACK CODE")="AA":"SU",1:"AE")
  .S ACK("ACK TO")=$G(HLMSTATE("HDR","MESSAGE CONTROL ID"))
  .S ACK("ACK TO","IEN")=HLMSTATE("IEN")
@@ -117,17 +117,9 @@
  I LEN>20 S ERROR="QUEUE PARAMETER IS MAX 20 LENGTH",PARMS("QUEUE")=$E(PARMS("QUEUE"),1,20)
  I 'LEN S PARMS("QUEUE")="DEFAULT"
- D
- .N APPIEN
- .I $G(PARMS("SENDING APPLICATION"))="" D  Q
- ..S ERROR="SENDING APPLICATION IS REQUIRED"
- ..S PARMS("SENDING APPLICATION")=""
- .E  D  Q:'APPIEN
- ..S APPIEN=$$GETIEN^HLOAPP(PARMS("SENDING APPLICATION"))
- ..I 'APPIEN S ERROR="SENDING APPLICATION NOT FOUND IN THE HLO APPLICATION REGISTRY"
- .I $L($G(PARMS("SEQUENCE QUEUE"))) D
- ..I ($L(PARMS("SEQUENCE QUEUE"))>30) S ERROR="SEQUENCE QUEUE NAME > 30 CHARACTERS" Q
- ..I PARMS("SEQUENCE QUEUE")["^" S ERROR="SEQUENCE QUEUE NAME MAY NOT CONTAIN '^'" Q
- ..I $G(PARMS("APP ACK TYPE"))'="AL" S ERROR="SEQUENCE QUEUES REQUIRE AN APPLICATION ACKNOWLEDGMENT" Q
- ..I $G(PARMS("ACCEPT ACK TYPE"))'="AL" S ERROR="SEQUENCE QUEUES REQUIRE AN ACCEPT ACKNOWLEDGMENT" Q
+ I $G(PARMS("SENDING APPLICATION"))="" D
+ .S ERROR="SENDING APPLICATION IS REQUIRED"
+ .S PARMS("SENDING APPLICATION")=""
+ E  D
+ .I '$D(^HLD(779.2,"C",PARMS("SENDING APPLICATION"))) S ERROR="SENDING APPLICATION NOT FOUND IN THE HLO APPLICATION REGISTRY"
  ;
  ;move parameters into HLMSTATE
@@ -140,8 +132,6 @@
  S @SARY@("FAILURE RESPONSE")=$G(PARMS("FAILURE RESPONSE"))
  S @SARY@("QUEUE")=PARMS("QUEUE")
- S @SARY@("SEQUENCE QUEUE")=$G(PARMS("SEQUENCE QUEUE"))
  Q:$L(ERROR) 0
  Q 1
- ;
  ;
 SETCODE(SEG,VALUE,FIELD,COMP,REP) ;
@@ -165,15 +155,2 @@
  S @VAR=9,SEG(FIELD,REP,COMP,SUB)=$G(VALUE("ORIGINAL TEXT"))
  Q
- ;
-CHKWHO(HLMSTATE,WHOTO,ERROR) ;
- N RETURN,I
- S RETURN=1
- I '$$CHECKWHO^HLOASUB1(.WHOTO,.RETURN,.ERROR) S RETURN=0
- ;
- ;move parameters into HLMSTATE
- S HLMSTATE("STATUS","LINK IEN")=$G(RETURN("LINK IEN"))
- S HLMSTATE("STATUS","LINK NAME")=$G(RETURN("LINK NAME"))
- S HLMSTATE("STATUS","PORT")=$P($G(RETURN("RECEIVING FACILITY",2)),":",2)
- S HLMSTATE("HDR","RECEIVING APPLICATION")=$G(RETURN("RECEIVING APPLICATION"))
- F I=1:1:3 S HLMSTATE("HDR","RECEIVING FACILITY",I)=$G(RETURN("RECEIVING FACILITY",I))
- Q RETURN
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI3.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI3.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPI3.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOAPI3 ;ALB/CJM-HL7 - Developer API's for sending application acks ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,133,134,137**;Oct 13, 1995;Build 21
+HLOAPI3 ;ALB/CJM-HL7 - Developer API's for sending application acks ;03/13/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,133,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -92,5 +92,5 @@
  .I PARMS("EVENT")="",ACK("ACK TO","BODY"),$P(SUB,"^",2) S PARMS("EVENT")=$P($G(^HLA(ACK("ACK TO","BODY"),2,$P(SUB,"^",2),0)),"^",3)
  .S PARMS("ACK TO")=PARMS("MESSAGE CONTROL ID")
- .S PARMS("ACK TO","STATUS")=$S(PARMS("ACK CODE")="AA":"SU",1:"ER")
+ .S PARMS("ACK TO","STATUS")=$S(PARMS("ACK CODE")="AA":"SU",1:"AE")
  .Q:'$$ADDMSG^HLOAPI(.ACK,.PARMS,.ERROR)
  .S ACK("MSA")="MSA|"_PARMS("ACK CODE")_"|"_PARMS("MESSAGE CONTROL ID")_"|"_$G(PARMS("ERROR MESSAGE"))
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPP.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOAPP.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOAPP.m	(revision 636)
@@ -1,9 +1,13 @@
-HLOAPP ;ALB/CJM-HL7 -Application Registry ;07/09/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,132,137**;Oct 13, 1995;Build 21
+HLOAPP ;ALB/CJM-HL7 -Application Registry ;10/31/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**126,132**;Oct 13, 1995;Build 6
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
 GETIEN(NAME) ;given the application name, it finds the ien.  Returns 0 on failure
  Q:'$L($G(NAME)) 0
- Q +$O(^HLD(779.2,"C",$E(NAME,1,60),0))
+ N IEN,SUB
+ S SUB=$E(NAME,1,60)
+ S IEN=0
+ F  S IEN=$O(^HLD(779.2,"B",SUB,IEN)) Q:'IEN  Q:$P($G(^HLD(779.2,IEN,0)),"^")=NAME
+ Q +IEN
  ;
 ACTION(HEADER,ACTION,QUEUE) ;Given the parsed header of a message it returns both the action that should be performed in response to the message and the incoming queue that it should be placed on.
@@ -93,24 +97,2 @@
  S:SUBIEN ACTIVE='(+$P($G(^HLD(779.2,IEN,1,SUBIEN,0)),"^",7))
  Q ACTIVE
- ;
-EXCEPT(APPNAME) ;
- ;returns the exception handler (tag^routine) that should be invoked
- ;when an applicaiton's messages are being sequenced and an app ack
- ;is not timely received
- ;
- N IEN,RTN
- S IEN=$$GETIEN($G(APPNAME))
- I IEN S RTN=$P($G(^HLD(779.2,IEN,0)),"^",10,11)
- I $L($G(RTN))>1 Q RTN
- Q "DEFAULT^HLOAPP"
- ;
-DEFAULT ;default exception handler if the app doesn't specify one
- S ^TMP("HLO SEQUENCING EXCEPTION",$J,$$NOW^XLFDT,+$G(HLMSGIEN))=""
- Q
- ;
-TIMEOUT(APPNAME) ;
- N IEN,TIME
- S IEN=$$GETIEN($G(APPNAME))
- I IEN S TIME=$P($G(^HLD(779.2,IEN,0)),"^",12)
- Q:'$G(TIME) 10
- Q TIME
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOCLNT ;ALB/CJM- Client for sending messages - 10/4/94 1pm ;08/15/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,134,137**;Oct 13, 1995;Build 21
+HLOCLNT ;ALB/CJM- Client for sending messages - 10/4/94 1pm ;03/22/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -155,6 +155,4 @@
  .;
  .;try to send the message
- .;
- .;
  .Q:'$$WRITEMSG^HLOCLNT1(.HLCSTATE,.HLMSTATE)
  .;does the message need an accept ack?
@@ -170,20 +168,10 @@
  ..S $P(UPDATE,"^",5)=1
  ..S UPDATE("MSA")=ACKID_"^"_MSA
- ..I '(ACKCODE="CA") S $P(UPDATE,"^",3)="ER",$P(UPDATE,"^",4)=2
+ ..I '(ACKCODE="CA") S $P(UPDATE,"^",3)="SE",$P(UPDATE,"^",4)=2
  ..I ACKCODE="CA",HLMSTATE("HDR","APP ACK TYPE")="NE" S $P(UPDATE,"^",3)="SU",$P(UPDATE,"^",4)=$S(HLMSTATE("BATCH"):"2",1:1)
- ..I ($P(UPDATE,"^",3)="ER") S $P(UPDATE,"^",6)=$P(HLMSTATE("HDR",1),FS,5) ;errors need the application for xref
+ ..I ($P(UPDATE,"^",3)="SE") S $P(UPDATE,"^",6)=$P(HLMSTATE("HDR",1),FS,5) ;errors need the application for xref
  ..;
- ..;if it's from a sequence queue, timestamp the queue
- ..I $L($G(HLMSTATE("STATUS","SEQUENCE QUEUE"))) D
- ...L +^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE")):200
- ...I $P($G(^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE"))),"^")'=MSGIEN L -^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE")) Q
- ...I ACKCODE="CA" S $P(^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE")),"^",2)=$$FMADD^XLFDT($P(UPDATE,"^",2),,,$$TIMEOUT^HLOAPP($$GETSAP^HLOCLNT2(MSGIEN))) L -^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE")) Q
- ...;if the message wasn't accepted, need to notify without waiting
- ...S $P(^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE")),"^",2)=$P(UPDATE,"^",2)
- ...L -^HLB("QUEUE","SEQUENCE",HLMSTATE("STATUS","SEQUENCE QUEUE"))
- ..;
- ..;does the app need notification of accept ack?
+ ..;did the app request notification of accept ack?
  ..S UPDATE("ACTION")=HLMSTATE("ACCEPT ACK RESPONSE")
- ..;
  ..S SUCCESS=1
  .E  D  ;accept ack wasn't requested
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT1.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT1.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT1.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOCLNT1 ;IRMFO-ALB/CJM - Writing messages, reading acks;03/24/2004  14:43 ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,134,137**;Oct 13, 1995;Build 21
+HLOCLNT1 ;IRMFO-ALB/CJM - Writing messages, reading acks;03/24/2004  14:43 ;03/19/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -146,5 +146,5 @@
  ...S $P(^HLB(MSG,0),"^",21)=COUNT_" FAILED TRANSMISSIONS"
  ...S $P(^HLB(MSG,0),"^",20)="TF"
- ...S ^HLB("ERRORS",RAPP,TIME,MSG)=""
+ ...S ^HLB("ERRORS","TF",SAPP,TIME,MSG)=""
  ...D COUNT^HLOESTAT("OUT",RAPP,SAPP,MTYPE,EVENT)
  ...S ACTION=$P(NODE0,"^",14,15)
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT2.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT2.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT2.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOCLNT2 ;ALB/CJM- Performs message updates for the client - 10/4/94 1pm ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,133,134,137**;Oct 13, 1995;Build 21
+HLOCLNT2 ;ALB/CJM- Performs message updates for the client - 10/4/94 1pm ;03/09/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,130,131,133,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -53,7 +53,7 @@
 UPDATE(MSGIEN,TIME,PARMS) ;
  S:PARMS("STATUS")]"" $P(^HLB(MSGIEN,0),"^",20)=PARMS("STATUS")
- I PARMS("STATUS")="ER" D
- .S ^HLB("ERRORS",PARMS("RECEIVING APP"),TIME,MSGIEN_"^")=""
- .D COUNT^HLOESTAT("OUT",PARMS("RECEIVING APP"),$$GETSAP(MSGIEN),$$GETMTYPE(MSGIEN))
+ S:PARMS("STATUS")="SE" ^HLB("ERRORS","SE",PARMS("RECEIVING APP"),TIME,MSGIEN)=""
+ S:PARMS("STATUS")="AE" ^HLB("ERRORS","AE",PARMS("RECEIVING APP"),TIME,MSGIEN_"^")=""
+ I PARMS("STATUS")["E" D COUNT^HLOESTAT("OUT",PARMS("RECEIVING APP"),$$GETSAP(MSGIEN),$$GETMTYPE(MSGIEN))
  S:PARMS("ACCEPT ACK") $P(^HLB(MSGIEN,0),"^",17)=PARMS("ACCEPT ACK")
  S $P(^HLB(MSGIEN,0),"^",16)=TIME
@@ -101,5 +101,4 @@
  ;    "ID" - message id from the header
  ;    "IEN" - ien, file 778
- ;    "STATUS","SEQUENCE QUEUE")=name of the sequence queue (optional)
  ;
  K MSG
@@ -147,5 +146,4 @@
  .S MSG("HDR","ACCEPT ACK TYPE")=$E($P($P(MSG("HDR",2),FS,4),"ACCEPT ACK TYPE=",2),1,2)
  .S MSG("HDR","APP ACK TYPE")=$E($P($P(MSG("HDR",2),FS,4),"APP ACK TYPE=",2),1,2)
- S MSG("STATUS","SEQUENCE QUEUE")=$P($G(^HLB(IEN,5)),"^")
  Q 1
  ;
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT3.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT3.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCLNT3.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOCLNT3 ;ALB/CJM- Updates messages missing application acks - 10/4/94 1pm ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,130,134,137**;Oct 13, 1995;Build 21
+HLOCLNT3 ;ALB/CJM- Updates messages missing application acks - 10/4/94 1pm ;03/22/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,130,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -29,9 +29,9 @@
  .S $P(^HLB(MSGIEN,0),"^",9)=PURGE
  .S ^HLB("AD","OUT",PURGE,MSGIEN)=""
- .S $P(^HLB(MSGIEN,0),"^",20)="ER"
+ .S $P(^HLB(MSGIEN,0),"^",20)="AE"
  .S $P(^HLB(MSGIEN,0),"^",21)="MISSING APPLICATION ACKNOWLEDGMENT"
  .M HDR=MSG("HDR")
  .Q:'$$PARSEHDR^HLOPRS(.HDR)
- .S ^HLB("ERRORS",$S($L(HDR("RECEIVING APPLICATION")):HDR("RECEIVING APPLICATION"),1:"UNKNOWN"),NOW,MSGIEN)=""
+ .S ^HLB("ERRORS","AE",$S($L(HDR("RECEIVING APPLICATION")):HDR("RECEIVING APPLICATION"),1:"UNKNOWN"),NOW,MSGIEN)=""
  .D COUNT^HLOESTAT("OUT",HDR("RECEIVING APPLICATION"),HDR("SENDING APPLICATION"),$S(MSG("BATCH"):"BATCH",1:$G(HDR("MESSAGE TYPE"))),$G(HDR("EVENT")))
  S:MSGIEN>99999999999 MSGIEN=0
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCNRT.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOCNRT.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOCNRT.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOCNRT ;DAOU/ALA-Generate HL7 Optimized Message ;07/24/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,132,134,137**;Oct 13, 1995;Build 21
+HLOCNRT ;DAOU/ALA-Generate HL7 Optimized Message ;03/15/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,132,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -17,9 +17,8 @@
  ;   ARYTYP = The array where HL7 message resides
  ;   HLP = Additional HL7 message parameters (optional, pass by reference)
- ;        These optional subscripts to HLP are supported for input:
- ;             "APP ACK RESPONSE" = <tag^routine> to call when the app ack is received
- ;             "CONTPTR"
+ ;        These optional subscripts to HLL are supported for input:
  ;             "SECURITY"
- ;             "SEQUENCE QUEUE" - queue used to maintain the order of the messages via application acks.  If used, the application MUST specify that both an accept ack and application ack be returned. 
+ ;              "CONTPTR"
+ ;              "APP ACK RESPONSE" = <tag^routine> to call when the app ack is received
  ;        
  ;   HLL  (optional, pass by reference) Additional message recipients being dynamically added
@@ -51,5 +50,4 @@
  . I $G(HLP("CONTPTR"))'="" S APPARMS("CONTINUATION POINTER")=HLP("CONTPTR")
  . I $G(HLP("QUEUE"))'="" S APPARMS("QUEUE")=HLP("QUEUE")
- . I $G(HLP("SEQUENCE QUEUE"))'="" S APPARMS("SEQUENCE QUEUE")=HLP("SEQUENCE QUEUE")
  . I $G(HLP("APP ACK RESPONSE"))'="" S APPARMS("APP ACK RESPONSE")=HLP("APP ACK RESPONSE")
  ;
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOF778.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOF778.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOF778.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOF778 ;ALB/CJM-HL7 - Saving messages to file 778 ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,134,137**;Oct 13, 1995;Build 21
+HLOF778 ;ALB/CJM-HL7 - Saving messages to file 778 ;03/15/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -142,9 +142,9 @@
  .S $P(^HLB(IEN,3,SUBIEN,0),"^",4)=$G(ACKTO("ACK BY"))
  .S $P(^HLB(IEN,3,SUBIEN,0),"^",5)=STATUS
- I (STATUS="ER"),'SKIP D
+ I (STATUS="AE"),'SKIP D
  .N APP
- .S APP=HLMSTATE("HDR","RECEIVING APPLICATION")
+ .S APP=HLMSTATE("HDR","SENDING APPLICATION")
  .I APP="" S APP="UNKNOWN"
- .S ^HLB("ERRORS",APP,$$NOW^XLFDT,ACKTO("IEN"))=""
+ .S ^HLB("ERRORS","AE",APP,$$NOW^XLFDT,ACKTO("IEN"))=""
  .;don't count the error - the app ack was already counted as an error.
  .D COUNT^HLOESTAT("IN",$G(HLMSTATE("HDR","RECEIVING APPLICATION")),$G(HLMSTATE("HDR","SENDING APPLICATION")),$S(HLMSTATE("BATCH"):"BATCH",1:$G(HLMSTATE("HDR","MESSAGE TYPE"))),$G(HLMSTATE("HDR","EVENT")))
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOF778A.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOF778A.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOF778A.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOF778A ;ALB/CJM-HL7 - Saving messages to file 778 (continued) ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,134,137**;Oct 13, 1995;Build 21
+HLOF778A ;ALB/CJM-HL7 - Saving messages to file 778 (continued) ;03/07/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -47,6 +47,6 @@
  .S ^HLB("B",ID,IEN)=""
  .S ^HLB("C",HLMSTATE("BODY"),IEN)=""
- .I ($G(@STAT)="ER") D
- ..S ^HLB("ERRORS",$S($L($G(HLMSTATE("HDR","RECEIVING APPLICATION"))):HLMSTATE("HDR","RECEIVING APPLICATION"),1:"UNKNOWN"),HLMSTATE("DT/TM CREATED"),IEN)=""
+ .I ($G(@STAT)="SE") D
+ ..S ^HLB("ERRORS","SE",$S($L($G(HLMSTATE("HDR","RECEIVING APPLICATION"))):HLMSTATE("HDR","RECEIVING APPLICATION"),1:"UNKNOWN"),HLMSTATE("DT/TM CREATED"),IEN)=""
  ..D COUNT^HLOESTAT("OUT",$G(HLMSTATE("HDR","RECEIVING APPLICATION")),$G(HLMSTATE("HDR","SENDING APPLICATION")),$S(HLMSTATE("BATCH"):"BATCH",1:$G(HLMSTATE("HDR","MESSAGE TYPE"))),$G(HLMSTATE("HDR","EVENT")))
  .;
@@ -70,7 +70,4 @@
  ;The "SEARCH" x-ref will be created asynchronously
  S ^HLTMP("PENDING SEARCH X-REF",$J,HLMSTATE("DT/TM CREATED"),IEN)=""
- ;
- ;sequence q?
- I HLMSTATE("DIRECTION")="OUT",$G(@STAT@("SEQUENCE QUEUE"))'="" S ^HLB(IEN,5)=@STAT@("SEQUENCE QUEUE")
  ;
  Q IEN
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOFILER.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLOFILER.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLOFILER.m	(revision 636)
@@ -1,4 +1,4 @@
-HLOFILER ;ALB/CJM- Passes messages on the incoming queue to the applications - 10/4/94 1pm ;07/10/2007
- ;;1.6;HEALTH LEVEL SEVEN;**126,131,134,137**;Oct 13, 1995;Build 21
+HLOFILER ;ALB/CJM- Passes messages on the incoming queue to the applications - 10/4/94 1pm ;03/28/2007
+ ;;1.6;HEALTH LEVEL SEVEN;**126,131,134**;Oct 13, 1995;Build 30
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -115,5 +115,5 @@
  D DEQUE()
  ;
- ;may need to change the status to Error
+ ;may need to change the status to Application Error
  D
  .N NODE,RAPP,SAPP,FS,CS,REP,ESCAPE,SUBCOMP,HDR,DIR,NOW
@@ -121,6 +121,6 @@
  .S NODE=$G(^HLB(MSGIEN,0))
  .Q:NODE=""
- .Q:$P(NODE,"^",20)="ER"
- .S $P(NODE,"^",20)="ER",$P(NODE,"^",21)="APPLICATION ROUTINE ERROR"
+ .Q:$P(NODE,"^",20)="AE"
+ .S $P(NODE,"^",20)="AE",$P(NODE,"^",21)="APPLICATION ROUTINE ERROR"
  .S DIR=$S($E($P(NODE,"^",4))="I":"IN",1:"OUT")
  .I $P(NODE,"^",9) K ^HLB("AD",DIR,$P(NODE,"^",9),MSGIEN)
@@ -138,5 +138,5 @@
  .I RAPP="" S RAPP="UNKNOWN"
  .S SAPP=$$DESCAPE^HLOPRS1($P($P(HDR,FS,3),CS),FS,CS,SUBCOMP,REP,ESCAPE)
- .S ^HLB("ERRORS",RAPP,NOW,MSGIEN)=""
+ .S ^HLB("ERRORS","AE",RAPP,NOW,MSGIEN)=""
  .D COUNT^HLOESTAT(DIR,RAPP,SAPP,"UNKNOWN")
  ;
